{"openapi":"3.0.0","info":{"title":"12plus API Documentation","description":"# Introduction\n\nWelcome to the 12plus API !\n\n## What is 12plus API?\n\nThe 12plus API is a REST interface to enable the creation and management of labels and orders.\n\nOur API accepts JSON content in requests and returns JSON content in all of its responses.\n\nThe HTTP methods (GET, POST, PATCH, DELETE) determine the operation type on the resource. The resource is identified by the URL, which is targeted by the method.\n\n# Getting Started\n\nBefore starting, you have to create an account in order to have the credential to use the API\n\nYou can contact the 12plus sale team here [Contact Us](mailto:contact@12plus.fr) to get it.\n  \n# What is a Rest Api ?\n\nA restful api is an application program interface (API) that uses HTTP requests to GET, PUT, PATCH, POST and DELETE data\n\nRest or Representational State Transfer is an architectural style for HTTP communication between computer systems on the web aiming to make it simpler and clearer.\n\n# Authentication\n\n## Bearer Token\n\nBearer authentication (also called token authentication) is an HTTP authentication scheme that involves security tokens called bearer tokens. The name “Bearer authentication” can be understood as “give access to the bearer of this token.” The bearer token is a cryptic string, usually generated by the server in response to a login request. The client must send this token in the Authorization header when making requests to protected resources:\n\n`Authorization: Bearer <token>`\n\n## How to get the token ?\n\nTo get the token you have to sign via this endpoint /authenticate with your credentials\n\nYou can see the detail of the request below in the documentation in the Authentication endpoint section\n\n`POST base_url/authenticate`\n\nThe response will provide the token to access the API.\n\n# Swagger\n\nSwagger provides a dynamic interface to try out the API endpoints.\nIt's really usefull to earn some times during the integration of the API\n\n## 1. How to use swagger to test the API ?\n\nThe sections below explain you how to use each part of the dynamic documentation.\n\n### 2. Servers\n\nHere you can choose an environnement to make your tests, 3 options are availables : API Auto Mocking, Production API and Staging API\n\nI advise you to use the Staging API to make your tests to avoid to be invoice.\n\nContact the commercial team in order to create a staging account.\n\n### 3. Authorize buttons\n\nThis button allows you to add the bearer token to the swagger environment, the token will be added to each request under the key `Authorization: Bearer {token}`\n\n### 4. Endpoints\n\nIn the next section,there is a list of all available endpoints.\n\nOn each endpoint, you could find a documentation about the url, params, payload and response.\nIt's possible to try each endpoint thanks to the button **Try it out**\n\nFor each endpoint the request body example and schema is provided\n\n# Create your first label\n\nTo create your first Label, you will need to follow these 2 steps:\n\n1. Get the token\n2. Generate the label\n\nBe careful, if you are in the Sandbox environment, don't forget to generate the token for this environment\n\n## STEP 1 : Get the token\n\nYou will now get the token to authenticate your next requests\n\n```\ncurl -X 'POST' \\\n  'https://{baseUrl}/authenticate' \\\n  -H 'accept: application/json' \\\n  -H 'Content-Type: application/json' \\\n  -d '{\n  \"email\": \"address@gmail.com\",\n  \"password\": \"password\"\n}'\n```\n\n## STEP 2 : Generate the label\n\nYou will now generate the label\n\n```\ncurl -X 'POST' \\\n'https://{baseUrl}/labels/generate_label' \\\n-H 'accept: application/json' \\\n-H 'Content-Type: application/json' \\\n-H 'Authorization: Bearer {token}' \\\n-d '{}' # you can find the payload at the endpoint\n```\n\nIf everything went well, you’ll receive a HTTP 200 status code and a response back with some important information like the trackingNumber\n\nYou can find the response format under the endpoint\n\n# Troubleshotting\n\nA documentation about the errors should be found under each endpoint.\n\n# Technical Support\n\nWe’re here to support you with any questions you might have about our API, or otherwise.\n","contact":{"email":"florian.donadei@gmail.com"},"license":{"name":"Apache 2.0","url":"http://www.apache.org/licenses/LICENSE-2.0.html"},"version":"1.2.0"},"servers":[{"url":"https://virtserver.swaggerhub.com/floriandonod/12plus2/1.0.0","description":"SwaggerHub API Auto Mocking"},{"url":"https://undeplus.herokuapp.com/api/v1","description":"Production API 12plus"},{"url":"https://preprod-12plus.herokuapp.com/api/v1","description":"Staging API 12plus"}],"security":[{"bearerAuth":[]}],"tags":[{"name":"authentication","description":"authentication endpoint"},{"name":"labels","description":"Labels endpoints"},{"name":"invoices","description":"Invoices endpoints"},{"name":"carrier_services","description":"Get the carriers and their available services for a defined country."},{"name":"pickup_requests","description":"pickup_requests endpoints"},{"name":"orders","description":"orders endpoints"}],"paths":{"/authenticate":{"post":{"tags":["authentication"],"summary":"Fetch a token","description":"Fetch a token (The Token expired after 24 hours)","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/authenticate_body"}}}},"responses":{"200":{"description":"success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_200"}}}},"401":{"description":"Invalid Credential","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_401"}}}}},"security":[{"bearerAuth":[]}]}},"/labels":{"get":{"tags":["labels"],"summary":"searches labels","description":"By passing in the appropriate params, you can search for\navailable labels in the system\n","operationId":"searchLabels","parameters":[{"name":"page","in":"query","description":"the current page","required":false,"style":"form","explode":true,"schema":{"minimum":1,"type":"integer","example":1}},{"name":"per_page","in":"query","description":"number of records in one page","required":false,"style":"form","explode":true,"schema":{"minimum":1,"type":"integer","example":50}},{"name":"id","in":"query","description":"the uniq id of the label","required":false,"style":"form","explode":true,"schema":{"type":"integer"}},{"name":"reference","in":"query","description":"the tracking number of the package","required":false,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"carrier_name","in":"query","description":"The carrier name","required":false,"style":"form","explode":true,"schema":{"type":"string","example":"Laposte"}},{"name":"type","in":"query","description":"The type of label","required":false,"style":"form","explode":true,"schema":{"type":"string","example":"Label","enum":["Label","Label::Return"]}},{"name":"destination_country","in":"query","description":"The destination country of the package","required":false,"style":"form","explode":true,"schema":{"type":"string","example":"DE"}},{"name":"declared_weight","in":"query","description":"The declared weight of the package (gram)","required":false,"style":"form","explode":true,"schema":{"type":"string","example":"100"}},{"name":"carrier_service_name","in":"query","description":"The carrier service name","required":false,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"created_at","in":"query","description":"The creation date of the label","required":false,"style":"form","explode":true,"schema":{"type":"string","example":"20/05/2020"}}],"responses":{"200":{"description":"search results matching criteria","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_200_1"}}}}},"security":[{"bearerAuth":[]}]}},"/labels/generate_label":{"post":{"tags":["labels"],"summary":"Create label","description":"This endpoint allows to create a label to ship your package","operationId":"createLabel","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/labels_generate_label_body"}}}},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_200_2"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_400"}}}},"401":{"description":"Unauthorized"}}}},"/orders":{"get":{"tags":["orders"],"summary":"searches orders","description":"By passing in the appropriate params, you can search for\navailable orders in the system\n","operationId":"searchOrders","parameters":[{"name":"page","in":"query","description":"the current page","required":false,"style":"form","explode":true,"schema":{"minimum":1,"type":"integer","example":1}},{"name":"per_page","in":"query","description":"number of records in one page","required":false,"style":"form","explode":true,"schema":{"minimum":1,"type":"integer","example":50}},{"name":"id","in":"query","description":"the uniq id of the label","required":false,"style":"form","explode":true,"schema":{"type":"integer"}},{"name":"tracking_number","in":"query","description":"the tracking number of the package","required":false,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"source_ref","in":"query","description":"The reference on the source","required":false,"style":"form","explode":true,"schema":{"type":"string","example":"13215489"}},{"name":"weight","in":"query","description":"weight (grams)","required":false,"style":"form","explode":true,"schema":{"type":"string","example":"1000"}}],"responses":{"200":{"description":"search results matching criteria","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_200_3"}}}}},"security":[{"bearerAuth":[]}]},"post":{"tags":["orders"],"summary":"Create orders","description":"You can create orders","operationId":"createOrder","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/orders_body"}}}},"responses":{"200":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_200_3"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_400_1"}}}},"401":{"description":"Unauthorized"}}}},"/invoices":{"get":{"tags":["invoices"],"summary":"get Invoices","description":"By passing in the appropriate params, you can search for\navailable invoices in the system\n","operationId":"getInvoices","parameters":[{"name":"page","in":"query","description":"the current page","required":false,"style":"form","explode":true,"schema":{"minimum":1,"type":"integer","example":1}},{"name":"per_page","in":"query","description":"number of records in one page","required":false,"style":"form","explode":true,"schema":{"minimum":1,"type":"integer","example":50}},{"name":"id","in":"query","description":"the uniq id of the invoice","required":false,"style":"form","explode":true,"schema":{"type":"integer"}},{"name":"number","in":"query","description":"the number of the invoice","required":false,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"invoice_type","in":"query","description":"the kind of the invoice","required":false,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"net_to_pay","in":"query","description":"the amount to pay","required":false,"style":"form","explode":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"search results matching criteria","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_200_4"}}}}},"security":[{"bearerAuth":[]}]}},"/invoices/{id}":{"get":{"tags":["invoices"],"summary":"get invoice by id","description":"By passing in the appropriate params, you can search for\navailable invoices in the system\n","operationId":"getInvoice","parameters":[{"name":"id","in":"path","description":"ID of invoice to fetch","required":true,"style":"simple","explode":false,"schema":{"type":"integer"}}],"responses":{"200":{"description":"search results matching criteria","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Invoice"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_401_1"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_404"}}}}},"security":[{"bearerAuth":[]}]}},"/labels/{id}":{"get":{"tags":["labels"],"summary":"get label by id","description":"By passing in the appropriate params, you can search for\navailable labels in the system\n","operationId":"getLabel","parameters":[{"name":"id","in":"path","description":"ID of label to fetch","required":true,"style":"simple","explode":false,"schema":{"type":"integer"}}],"responses":{"200":{"description":"search results matching criteria","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Label"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_401_1"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_404"}}}}},"security":[{"bearerAuth":[]}]}},"/labels/{reference}/delivery_states":{"get":{"tags":["labels","delivery states","delivery"],"summary":"get list of delivery states from any labels by reference","description":"By passing in the appropriate params, you can get the list of\ndelivery states from any of your labels\n","operationId":"getDeliveryStates","parameters":[{"name":"reference","in":"path","description":"reference of label to fetch","required":true,"style":"simple","explode":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"search results matching criteria","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeliveryState"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_401_1"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_404_1"}}}}},"security":[{"bearerAuth":[]}]}},"/carrier_services":{"get":{"tags":["carrier_services"],"summary":"get a carrier's services available for a given country","description":"By passing the iso alpha2 country code and optionally the name of a carrier you can get services available for your destination.\n\nIn order to generate a label, you have to use the field 'name' of the response in the field carrier_service_name in the generate_label payload.\n","parameters":[{"name":"destination_country_code","in":"query","description":"alpha2 iso code of the destination country, it should be uppercase","required":true,"style":"form","explode":true,"schema":{"type":"string"},"example":"FR"},{"name":"carrier_name","in":"query","description":"**The below table defines the carrier_name **\n\n| Carrier Name     |                              \n| ---------------- |\n| Laposte          |\n| Dhl              |\n| MondialRelay     |\n| ColisPrive       |\n| ---------------- | \n","required":false,"style":"form","explode":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"carrier services available for the destination country","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServicesResponse"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_400_2"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_404_2"}}}}},"security":[{"bearerAuth":[]}]}},"/labels/calc_price":{"get":{"tags":["pricing"],"summary":"get the shipping price of a package","description":"By passing some params, you could get the shipping price. If you also pass the dimensions of your package, its compliance with the carrier's dimension rules will be verified.","parameters":[{"name":"destination_country","in":"query","description":"alpha2 iso code of the destination country","required":true,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"shipping_country","in":"query","description":"alpha2 iso code of the origin country","required":true,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"carrier_name","in":"query","description":"Name of the carrier, the current possibilities are: Laposte, Dhl or Mondial Relay","required":true,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"carrier_service_name","in":"query","description":"Name of the service (you can get it whith the request /carrier_services/prices below)","required":true,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"declared_weight","in":"query","description":"the weight","required":true,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"length","in":"query","description":"the package length in cm","required":false,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"width","in":"query","description":"the package width in cm","required":false,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"height","in":"query","description":"the package height in cm","required":false,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"amount_insured","in":"query","description":"the value in cents that you want to insure (use this to get the insurance_price)","required":false,"style":"form","explode":true,"schema":{"type":"integer"},"example":10000}],"responses":{"200":{"description":"The pricing information for the given parameters.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PricingResponse"}}}},"400":{"description":"Error Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_400_3"}}}}},"security":[{"bearerAuth":[]}]}},"/labels/calc_assurance":{"get":{"tags":["pricing"],"summary":"get the insurance price","description":"By passing the carrier_name and the amount_insured, you can get the insurance price in €","parameters":[{"name":"carrier_name","in":"query","description":"the name of the carrier chosen for the shipping","required":true,"style":"form","explode":true,"schema":{"type":"string"},"example":"Dhl"},{"name":"amount_insured","in":"query","description":"the amount in cents that you want to insure","required":true,"style":"form","explode":true,"schema":{"type":"integer"},"example":25}],"responses":{"200":{"description":"The price in € of the insurance for the given parameters.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_200_5"}}}},"400":{"description":"Error Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_400_4"}}}}},"security":[{"bearerAuth":[]}]}},"/labels/calc_price_multiple_senders":{"post":{"tags":["pricing"],"summary":"get the shipping price of packages from multiple senders","description":"By passing some params, you could get the shipping price.","requestBody":{"content":{"application/json":{"schema":{"properties":{"destination_country":{"type":"string","nullable":false,"description":"alpha2 iso code of the destination country","example":"FR"},"senders":{"type":"array","items":{"type":"object","properties":{"ref":{"type":"string","description":"This ref allows to identify the sender, this ref will be userd in the response to get the price","example":"1"},"shipping_country":{"type":"string","nullable":false,"description":"alpha2 iso code of the origin country","example":"FR"},"carrier_name":{"type":"string","nullable":false,"description":"Name of the carrier, the current possibilities are: Laposte, Dhl or Mondial Relay","example":"Dhl"},"carrier_service_name":{"type":"string","nullable":false,"description":"Name of the service (you can get it whith the request /carrier_services/prices below) For Dhl for example, there are the options : ['n', 'd', 'p', 'u'] n -> national, d -> document, p -> monde, u -> europe","example":"n"},"items":{"type":"array","items":{"$ref":"#/components/schemas/item_senders"}}}}}}}}}},"responses":{"200":{"description":"The pricing information for the given parameters.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/MultipleSendersPricingResponse"}}}},"400":{"description":"Error Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_400_3"}}}}},"security":[{"bearerAuth":[]}]}},"/carrier_services/prices":{"get":{"tags":["pricing"],"summary":"get the carriers services prices for the given parameters","description":"By passing in the appropriate params, you can get the price of your shipping for all the available carriers services","parameters":[{"name":"destination_country_code","in":"query","description":"the destination country alpha2 iso code","required":true,"style":"form","explode":true,"schema":{"type":"string"},"example":"FR"},{"name":"weight","in":"query","description":"the package weight in grams","required":true,"style":"form","explode":true,"schema":{"type":"integer"},"example":1500},{"name":"relay","in":"query","description":"is relay service or not ?","required":false,"style":"form","explode":true,"schema":{"type":"string"},"example":"false"}],"responses":{"200":{"description":"The the carrier's services prices for the given parameters.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CarrierServicesPricesResponse"}}}}},"security":[{"bearerAuth":[]}]}},"/pickup_requests":{"get":{"tags":["pickup_requests"],"summary":"get pickup_requests of logged user","description":"By passing in the appropriate params, you can get and filter the pickup requests created by the logged user.\n","parameters":[{"name":"page","in":"query","description":"the current page","required":false,"style":"form","explode":true,"schema":{"minimum":1,"type":"integer","example":1}},{"name":"per_page","in":"query","description":"number of records in one page","required":false,"style":"form","explode":true,"schema":{"minimum":1,"type":"integer","example":50}},{"name":"already_picked_up","in":"query","description":"From the current date, the truck is already picked up the packages ?","required":false,"style":"form","explode":true,"schema":{"type":"boolean","example":true}},{"name":"passed","in":"query","description":"fill this param to get only the already passed pickup requests (the ones with the timestamp in the past)","required":false,"deprecated":true,"style":"form","explode":true,"schema":{"type":"boolean","example":true}},{"name":"planned","in":"query","description":"fill this param to get only the planned pickup requests (the ones with the timestamp in the future)","required":false,"deprecated":true,"style":"form","explode":true,"schema":{"type":"boolean","example":true}},{"name":"id","in":"query","description":"the uniq id of the pickup_request","required":false,"style":"form","explode":true,"schema":{"type":"integer"}},{"name":"dispatch_number","in":"query","description":"the dispatch number of the package return at its creation","required":false,"style":"form","explode":true,"schema":{"type":"string"}},{"name":"created_at","in":"query","description":"The creation date of the label","required":false,"style":"form","explode":true,"schema":{"type":"string","example":"20/05/2020"}}],"responses":{"200":{"description":"search results matching criteria","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_200_6"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_401_1"}}}}},"security":[{"bearerAuth":[]}]}},"/pickup_request/{id}":{"get":{"tags":["pickup_requests"],"summary":"get pickup_request by id","description":"You can get a pickup_request using its uniq id\n","parameters":[{"name":"id","in":"path","description":"ID of pickup_request to fetch","required":true,"style":"simple","explode":false,"schema":{"type":"integer"}}],"responses":{"200":{"description":"result matching pickup_request id","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PickupRequest"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_401_1"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_404_3"}}}}},"security":[{"bearerAuth":[]}]}},"/pickup_requests/generate_pickup_request":{"post":{"tags":["pickup_requests"],"summary":"Create pickup_request","description":"Generate a pickup request at the given address for your packages created maximum 4 days ago (between now and DateTime.current-4.days).beginning_of_day ) with no pickup already planned for them. Available for dhl only.","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/pickup_requests_generate_pickup_request_body"}}}},"responses":{"201":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_201"}}}},"400":{"description":"The error code 400 returns many kinds of errors. There are listed below with value 'possibleValueX'","content":{"application/json":{"schema":{"$ref":"#/components/schemas/inline_response_400_5"}}}},"401":{"description":"Unauthorized"}}}}},"components":{"schemas":{"Invoice":{"type":"object","properties":{"id":{"type":"string","example":"1234"},"name":{"type":"string","example":"1234"},"total_deposit":{"type":"string","description":"This value is only set on Reconciliation Invoice. It s the sum of the 4 deposit invoices","example":"10"},"net_to_pay":{"type":"string","description":"The amount to pay with tax included","example":"100"},"amount_tva":{"type":"string","description":"The tax amount","example":"2"},"price_ht":{"type":"string","description":"The amount to pay without tax","example":"5"},"price_ttc":{"type":"string","description":"The amount to pay with tax included (same as net_to_pay)","example":"7"},"total_real":{"type":"string","description":"This field is only fill in Reconciliation Invoice, there is the real amount to pay, then in this kind of invoice, the net_to_pay is equal to (total_real - total_deposit)","example":"15"},"type":{"type":"string","description":"There is two kind of invoices : \n\n 1. Deposit Invoice is generated each weeks, it's based on the declaration weight. \n\n 2. Reconciliation Invoice is generated once by month, it recalculate the difference between the declaration and the real weight (verified by the carriers). In this invoice we add all carrier taxes like oil, insurance, volumetric weight etc ... ","example":"Invoice::Deposit","enum":["Invoice::Deposit","Invoice::Reconciliation"]},"date":{"type":"string","description":"The invoice date","format":"date-time"},"client_name":{"type":"string","example":"Ali Gator"},"number":{"type":"string","description":"The invoice number","example":"F20200945"},"document":{"$ref":"#/components/schemas/Invoice_document"},"verified":{"type":"boolean","description":"The Invoice is available or not","example":true},"nb_shipping":{"type":"integer","description":"The number of package sent","example":95},"start_at":{"type":"string","description":"The invoice start date","format":"date-time"},"end_at":{"type":"string","description":"The invoice end date","format":"date-time"}}},"Label":{"type":"object","properties":{"id":{"type":"string","example":"1234"},"declared_weight":{"type":"string","description":"weight of the package at the declaration (grams)","example":"2500"},"assurance_value":{"type":"string","description":"the amount you need to insure (centimes)","nullable":true,"example":"150"},"assurance_price":{"type":"string","description":"the price of the chosen insurance (euros)","nullable":true,"example":"0.1"},"price":{"type":"string","description":"price based on the declared weight","example":"3.04"},"tva":{"type":"string","description":"tva applied on this label","example":"20"},"sb_created_at":{"type":"string","description":"created_at on shippingbo","format":"date-time"},"sb_shipped_at":{"type":"string","description":"shipped_at on shippingbo","format":"date-time"},"label_url":{"type":"string","description":"the url of the pdf label on shippingbo","example":"http://label_link_on_shippingbo.pdf"},"tracking_url":{"type":"string","description":"the url of the pdf label on shippingbo","nullable":true,"example":"http://tracking_link_label_on_shippingbo.pdf"},"measured_weight":{"type":"string","description":"weight of the package after Reconciliation (grams)","example":"2000"},"measured_assurance_value":{"type":"string","description":"insurance of the package after Reconciliation (grams)","example":"2000"},"price_reconciled":{"type":"string","description":"The price of the package after Reconciliation","example":"4.5"},"reference":{"type":"string","description":"The tracking number of the package","example":"6A1245845FD458"},"label_id_sb":{"type":"string","description":"Id of the label on Shippingbo","example":"15487542"},"carrier_name":{"type":"string","description":"The carrier name","example":"Laposte"},"carrier_service_name":{"type":"string","description":"The carrier service name","example":"so colissimo domicile avec signature - international"},"shipping_country":{"type":"string","description":"The shipping country (ISO 3166-1 alpha-2) (always FR)","example":"FR"},"destination_country":{"type":"string","description":"The shipping country (ISO 3166-1 alpha-2)","example":"FR"},"label_format":{"type":"string","description":"The label format","example":"pdf"},"recipient_name":{"type":"string","description":"The name of the customer","nullable":true,"example":"Terry Dicule"},"custom_reference":{"type":"string","description":"A custom Reference","nullable":true,"example":"as you want"},"client":{"$ref":"#/components/schemas/Label_client"}}},"Order":{"type":"object","properties":{"id":{"type":"string","example":"1234"},"source":{"type":"string","description":"the source where the order come from","nullable":false,"example":"Amazon"},"source_ref":{"type":"string","description":"the uniq identifier on the source","nullable":false,"example":"1234564897"},"weight":{"type":"string","description":"weight of the package (grams)","nullable":true,"example":"100"},"shipping_price":{"type":"string","description":"Shipping price (cents)","nullable":true,"example":"100"},"shipping_address":{"$ref":"#/components/schemas/Address"},"billing_address":{"$ref":"#/components/schemas/Address"},"relay_ref":{"type":"string","description":"relay_ref","nullable":true,"example":"100"},"origin_created_at":{"type":"string","description":"create_at on the source","nullable":true,"example":"2021-05-03T18:19:11.000Z"},"origin_state":{"type":"string","description":"state on the source","nullable":true,"example":"to_be_prepared"},"tracking_number":{"type":"string","description":"the tracking_number","nullable":true,"example":"6A20969974228"},"total_price_tax_included":{"type":"string","description":"total_price_tax_included","nullable":true,"example":"100"},"shipping_price_tax_included":{"type":"string","description":"shipping_price_tax_included","nullable":true,"example":"100"},"description":{"type":"string","description":"description : limit 35","nullable":true,"example":"Books"},"length":{"type":"string","description":"length (cm)","nullable":true,"example":"30"},"width":{"type":"string","description":"width (cm)","nullable":true,"example":"20"},"height":{"type":"string","description":"height (cm)","nullable":true,"example":"10"},"shipped_at":{"type":"string","description":"shipped_at","nullable":true,"example":"2021-05-03T18:19:11.000Z"},"total_price":{"type":"string","description":"total_price without taxes (cents)","nullable":true,"example":"1000"},"currency":{"type":"string","description":"currency","nullable":true,"example":"EUR"}}},"Address":{"type":"object","properties":{"id":{"type":"integer","description":"Uniq ID","nullable":false,"example":4},"firstname":{"type":"string","description":"firstname","example":"Barack"},"lastname":{"type":"string","description":"lastname","example":"Afritt"},"fullname":{"type":"string","description":"fullname","example":"Barack Afritt"},"phone1":{"type":"string","description":"phone1","example":"0606060606"},"phone2":{"type":"string","description":"phone2","example":"0561451246"},"email":{"type":"string","description":"email","example":"em@il.fr"},"address_line1":{"type":"string","description":"address_line1","example":"28 rue matabiau"},"address_line2":{"type":"string","description":"address_line2","example":"apart 2"},"address_line3":{"type":"string","description":"address_line3","example":"bat c"},"zip":{"type":"string","description":"zip","example":"31000"},"country":{"type":"string","description":"country","example":"Barack Afritt"},"company_name":{"type":"string","description":"company_name","example":"FR"},"additional_information":{"type":"string","description":"additional_information","example":"other thing to write"},"tags":{"type":"string","description":"tags","example":"shipping or billing"},"order_id":{"type":"string","description":"order_id","example":"1234"},"state":{"type":"string","description":"state","example":"shipped"}}},"DeliveryState":{"type":"object","properties":{"id":{"type":"string","example":"1234"},"state":{"type":"string","description":"state","example":"shipped"},"state_info":{"type":"string","description":"state informations","nullable":true,"example":"L'emballage de votre colis a été renforcé pour en assurer sa livraison. Il est en cours d'acheminement."},"location":{"type":"string","description":"location","nullable":true,"example":"CDG"},"state_change_at":{"type":"string","description":"state_change_at provide by the carrier","format":"date-time"},"label_id":{"type":"string","description":"id label attached","example":"898778"},"created_at":{"type":"string","description":"created_at on 12PLUS","format":"date-time"},"updated_at":{"type":"string","description":"updated_at on 12PLUS","format":"date-time"},"code":{"type":"string","description":"Code returned by the carrier","example":"DCHRMA"}}},"PickupRequest":{"type":"object","properties":{"id":{"type":"integer","description":"Uniq ID of the pickup request","nullable":false,"example":4},"carrier_name":{"type":"string","description":"Name of the carrier, the current possibilities are: [Dhl]","nullable":false,"example":"Dhl"},"pickup_timetsamp":{"type":"string","description":"Identifies the date and time the package is tendered. The time is the local time of the shipment based on the shipper's time zone. The             date component must be in the format: YYYY-MM-DD; the time component must be in the format: HH:MM:SS using a 24 hour clock. The date              and time parts are separated by the letter T (e.g. 2010-02-05T14:00:00GMT+01:00). ","nullable":false,"example":"2020-08-18T10:00:00.000Z"},"pickup_location_close_time":{"type":"string","description":"Identifies the pickup location close time (i.e. what time do the premises where the collection is supposed to happen close). Thevalue must be in local time. The value component must be HH:MM (using a 24-hours clock format, e.g. 1:00).","nullable":false,"example":"19:00"},"pickup_location":{"type":"string","description":"Where the package should be picked up by DHL courier.","nullable":true,"example":"Mailbox"},"dispatch_number":{"type":"string","description":"Uniq dispatch number of the request, returned at its creation","nullable":false,"example":"CBJ180121002626"},"instructions":{"type":"string","description":"Any special instructions you wish to send to the courier for the order pick-up","nullable":true,"example":"Collect Carefully"},"created_at":{"type":"string","description":"The creation timestamp of the pickup_request","nullable":false,"example":"2020-09-03T15:00:08.739Z"},"pickup_address":{"$ref":"#/components/schemas/PickupRequest_pickup_address"}}},"PickupRequestError5005":{"type":"object","properties":{"@code":{"type":"integer","example":5005},"message":{"type":"string","example":"The minimum pickup time window overlap for your requested origin is a minimum of '90' minutes with a same day pickup initiated latest by '17:30' today. Please note that couriers are available for a pickup at the requested origin between '12:00' and '19:30'. Times are based on the origin timezone."}},"description":"Error Dhl"},"PickupRequestError5004":{"type":"object","properties":{"@code":{"type":"integer","example":5004},"message":{"type":"string","example":"The pickup request must be at least '1' hrs before the provided PickupLocationClose time."}},"description":"Error Dhl"},"PickupRequestError5003":{"type":"object","properties":{"@code":{"type":"integer","example":5003},"message":{"type":"string","example":"The Pickup time window overlap is too small. Please ensure that the overlap between your provided request and the courier pickup window has the minimum required Pickup Time window overlap."}},"description":"Error Dhl"},"ServicesResponse":{"type":"array","items":{"$ref":"#/components/schemas/ServicesResponse_inner"}},"CarrierServicesPricesResponse":{"type":"array","items":{"$ref":"#/components/schemas/CarrierServicesPricesResponse_inner"}},"MultipleSendersPricingResponse":{"type":"array","items":{"type":"object","properties":{"ref":{"type":"string","description":"the sender reference","example":"1"},"shipping_price":{"type":"number","description":"theshipping price","example":"10"},"tva":{"type":"integer","description":"VAT of the shipping","example":"20"},"price_ttc":{"type":"number","description":"the shipping_price VAT included","example":"12"},"real_weight":{"type":"number","description":"The weight used to invoice the shipping in kg","example":"2.5"},"total_weight":{"type":"number","description":"The total weight of the items in kg","example":"2"},"volumetric_weight":{"type":"number","description":"The volumetric_weight of the shipping in kg (length * width * height / 5000)","example":"2.5"},"total_item_price":{"type":"number","description":"The price of all items in euros","example":"550"},"insurance_price":{"type":"number","description":"The insurance price in euros","example":"1.5"}}}},"PricingResponse":{"type":"object","properties":{"price":{"type":"integer","description":"The price in euros without any taxes"},"price_ttc":{"type":"integer","description":"The price in euros including tva and eventual fines"},"tva":{"type":"integer","description":"The percentage of the TVA tax for this shipping.","example":20},"status":{"type":"string","description":"The status of this pricing requested regarding to the carrier's dimension rules.","example":"FINED1","enum":["VALID","FINED1","REJECTED"]},"insurance_price":{"type":"integer","description":"the price in euros to insure you shipping for the amount_insured passed as a parameter","example":12},"message":{"type":"string","description":"A message for when the package does not comply with the carrier's dimension rules with details of the irregularity.","example":"Your package is too big and a fine of 6€ will be applied"},"fine_amount":{"type":"integer","description":"The amount in euros of the fine that will be applied for a package not conform to carrier dimensions rules","example":6},"max_dimensions":{"$ref":"#/components/schemas/PricingResponse_max_dimensions"}}},"Meta":{"type":"object","properties":{"current_page":{"type":"integer","description":"current page","example":1},"next_page":{"type":"integer","description":"next page","example":2},"prev_page":{"type":"integer","description":"prev page","example":2},"total_pages":{"type":"integer","description":"the total number of pages","example":10},"total_count":{"type":"integer","description":"the total number of records","example":100}}},"authenticate_body":{"type":"object","properties":{"email":{"type":"string","example":"address@gmail.com"},"password":{"type":"string","example":"password"}}},"inline_response_200":{"type":"object","properties":{"auth_token":{"type":"string","example":"eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI"}}},"inline_response_401":{"type":"object","properties":{"error":{"$ref":"#/components/schemas/inline_response_401_error"}}},"inline_response_200_1":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/Label"}},"meta":{"$ref":"#/components/schemas/Meta"}}},"labelsgenerate_label_cn23_data_products":{"type":"object","properties":{"country_code":{"maxLength":2,"type":"string","example":"FR"},"currency_code":{"maxLength":3,"type":"string","example":"EUR"},"description":{"maxLength":35,"type":"string","example":"book"},"hs_code":{"type":"string","description":"customs number: more info here: http://marcologistique.com/comment-comprendre-les-hs-codes/","nullable":true,"example":"08043010"},"quantity":{"type":"integer","description":"Quantity of the product: [1;99]","example":1},"unit_price":{"type":"string","description":"product unit price (in cents)","example":"25"},"weight":{"type":"string","description":"product unit weight in grams","example":"1000"}}},"labelsgenerate_label_cn23_data":{"type":"object","properties":{"category":{"type":"string","description":"products category, the possibles values are:","example":"1","enum":["1 for GIFT","2 for COMMERCIAL SAMPLE","3 for COMMERCIAL SHIPMENT","4 for DOCUMENT","6 for MERCHANDISE RETURN","5 for OTHER"]},"shipping_price":{"type":"string","description":"The price of shipping provided to the customs","nullable":true,"example":"10.25"},"products":{"type":"array","items":{"$ref":"#/components/schemas/labelsgenerate_label_cn23_data_products"}}},"description":"Data for the cn23 customs form needed for internationnal shipping","nullable":true},"labelsgenerate_label_sender":{"type":"object","properties":{"lastname":{"type":"string","example":"Bond"},"firstname":{"type":"string","example":"James"},"address_line1":{"maxLength":45,"type":"string","example":"3 Rue Gabriel Péri"},"address_line2":{"maxLength":45,"type":"string","nullable":true,"example":"Batiment A"},"address_line3":{"maxLength":45,"type":"string","nullable":true,"example":"Escalier B"},"country":{"maxLength":2,"type":"string","example":"FR"},"city":{"maxLength":35,"type":"string","example":"Toulouse"},"zip":{"maxLength":12,"type":"string","example":"31000"},"phone1":{"maxLength":25,"type":"string","example":"0506070809"},"email":{"maxLength":50,"type":"string","nullable":true,"example":"james.bond@spy.en"},"company_name":{"maxLength":60,"type":"string","example":"My Company"},"labelType":{"type":"string","description":"How to choose my labelType ?\n\nIt depends of the printer\n\nThe most common use case is PDF_A4_300dpi for printer and PDF_10x15_300dpi for thermic printer\n","example":"PDF_A4_300dpi","enum":["PDF_A4_300dpi","PDF_10x15_300dpi","ZPL_10x15_300dpi","ZPL_10x15_203dpi"]}},"description":"sender informations"},"labelsgenerate_label_recipient":{"type":"object","properties":{"lastname":{"type":"string","example":"Bond"},"firstname":{"type":"string","example":"James"},"fullname":{"maxLength":45,"type":"string","example":"James Bond"},"address_line1":{"maxLength":45,"type":"string","example":"3 Rue Gabriel Péri"},"address_line2":{"maxLength":45,"type":"string","example":"Batiment A"},"address_line3":{"maxLength":45,"type":"string","example":"Escalier B"},"country":{"maxLength":2,"type":"string","example":"FR"},"city":{"maxLength":35,"type":"string","example":"Toulouse"},"zip":{"maxLength":12,"type":"string","example":"31000"},"phone1":{"maxLength":25,"type":"string","example":"0506070809"},"email":{"maxLength":50,"type":"string","example":"james.bond@spy.en"},"relay_id":{"type":"string","example":"009024"}},"description":"recipient informations"},"labels_generate_label_body":{"type":"object","properties":{"weight":{"type":"string","description":"weight in grams","example":"7000"},"carrier_name":{"type":"string","description":"Provide the name of the carrier, the list of the available carrier is provided below : ","example":"Laposte","enum":["Laposte","Dhl","MondialRelay","ColisPrive"]},"carrier_service_name":{"type":"string","description":"The lsit of the carrier service names is provided below\n\nHowever a service can be use for only some countries :\nTo be sure you can use the endpoint `GET /carrier_services/services` with the country in params to see the avaiblable service for this country\n","example":"so colissimo domicile sans signature - france","enum":["colissimo access om","colissimo expert om","so colissimo domicile avec signature - international","so colissimo domicile sans signature - france","so colissimo domicile avec signature - france","so colissimo domicile sans signature - international","colissimoexpertinternational","colissimo retour france","colissimo retour international","so colissimo relais commerçant - france","so colissimo bureau de poste - france","n (DOMESTIC EXPRESS)","p (EXPRESS WORLDWIDE (ECX))","u (EXPRESS WORLDWIDE (ECX))","d (EXPRESS WORLDWIDE (DOX))"]},"assurance_value":{"type":"integer","description":"insured value in cents","example":2500},"custom_reference":{"type":"string","nullable":true,"example":"Your custom reference, it allow to add a custom reference to the label for your own needs"},"width":{"type":"string","description":"width of the package in centimeters, mandatory for Dhl labels","nullable":true,"example":"10"},"height":{"type":"string","description":"height of the package in centimeters, mandatory for Dhl labels","nullable":true,"example":"10"},"length":{"type":"string","description":"length of the package in centimeters, mandatory for Dhl labels","nullable":true,"example":"10"},"description":{"maxLength":35,"type":"string","description":"description of the products, prefered in english, mandatory for Dhl labels","nullable":true,"example":"BOOKS"},"invoice_base64":{"maxLength":35,"type":"string","description":"provide the base64 of the invoice, it will be provided to the customs for the paperless system.","nullable":true,"example":"base64 file"},"cn23_data":{"$ref":"#/components/schemas/labelsgenerate_label_cn23_data"},"sender":{"$ref":"#/components/schemas/labelsgenerate_label_sender"},"recipient":{"$ref":"#/components/schemas/labelsgenerate_label_recipient"}}},"inline_response_200_2":{"properties":{"message":{"type":"string","example":"Etiquette imprimée avec succès"},"reference":{"type":"string","description":"Created label's unique reference usable to get it. This reference allow you to track the package.","example":"JD011100003640582624"},"label_url":{"type":"string","description":"URL of the label document","example":"http://res.cloudinary.com/hrrvmua1s/image/upload/vXXXXXXXXXXX/X/manual_labels/label_XXXXXXXXXXXX_2020-XX-XX.pdf"},"id":{"type":"string","description":"12plus id of the label","example":"123456"},"tracking_url":{"type":"string","description":"Link to track your package","example":"http://laposte.fr/tracking/JD011100003640582624"}}},"inline_response_400":{"properties":{"message":{"type":"string","example":"missing mandatory param 'weight'"}}},"inline_response_200_3":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/Order"}},"meta":{"$ref":"#/components/schemas/Meta"}}},"orders_shipping_address":{"type":"object","properties":{"lastname":{"type":"string","example":"Bond"},"firstname":{"type":"string","example":"James"},"address_line1":{"maxLength":45,"type":"string","example":"3 Rue Gabriel Péri"},"address_line2":{"maxLength":45,"type":"string","nullable":true,"example":"Batiment A"},"address_line3":{"maxLength":45,"type":"string","nullable":true,"example":"Escalier B"},"country":{"maxLength":2,"type":"string","example":"FR"},"city":{"maxLength":35,"type":"string","example":"Toulouse"},"zip":{"maxLength":12,"type":"string","example":"31000"},"phone1":{"maxLength":25,"type":"string","example":"0606070809"},"phone2":{"maxLength":25,"type":"string","example":"0506070809"},"email":{"maxLength":50,"type":"string","nullable":true,"example":"james.bond@spy.en"},"company_name":{"maxLength":60,"type":"string","example":"My Company"}},"description":"recipient informations"},"orders_billing_address":{"type":"object","properties":{"lastname":{"type":"string","example":"Bond"},"firstname":{"type":"string","example":"James"},"fullname":{"maxLength":45,"type":"string","example":"James Bond"},"address_line1":{"maxLength":45,"type":"string","example":"3 Rue Gabriel Péri"},"address_line2":{"maxLength":45,"type":"string","example":"Batiment A"},"address_line3":{"maxLength":45,"type":"string","example":"Escalier B"},"country":{"maxLength":2,"type":"string","example":"FR"},"city":{"maxLength":35,"type":"string","example":"Toulouse"},"zip":{"maxLength":12,"type":"string","example":"31000"},"phone1":{"maxLength":25,"type":"string","example":"0506070809"},"phone2":{"maxLength":25,"type":"string","example":"0506070809"},"email":{"maxLength":50,"type":"string","example":"james.bond@spy.en"}},"description":"recipient informations"},"orders_body":{"type":"object","properties":{"weight":{"type":"string","description":"weight in grams","example":"7000"},"currency":{"type":"string","description":"currency","example":"EUR"},"source_ref":{"type":"string","description":"the uniq source reference","nullable":true,"example":"123456"},"source":{"type":"string","description":"the order source","nullable":true,"example":"Amazon"},"width":{"type":"string","description":"width of the package in centimeters, mandatory for Dhl labels","nullable":true,"example":"10"},"height":{"type":"string","description":"height of the package in centimeters, mandatory for Dhl labels","nullable":true,"example":"10"},"length":{"type":"string","description":"length of the package in centimeters, mandatory for Dhl labels","nullable":true,"example":"10"},"description":{"maxLength":35,"type":"string","description":"description of the products, prefered in english, mandatory for Dhl labels","nullable":true,"example":"BOOKS"},"shipping_address":{"$ref":"#/components/schemas/orders_shipping_address"},"billing_address":{"$ref":"#/components/schemas/orders_billing_address"}}},"inline_response_400_1":{"properties":{"message":{"type":"string","example":"missing mandatory param 'source_ref'"}}},"inline_response_200_4":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/Invoice"}},"meta":{"$ref":"#/components/schemas/Meta"}}},"inline_response_401_1":{"type":"object","properties":{"error":{"type":"string","example":"You are not authorized to access this page."}}},"inline_response_404":{"type":"object","properties":{"error":{"type":"string","example":"Couldn't find Label with 'id'=xxxx"}}},"inline_response_404_1":{"type":"object","properties":{"error":{"type":"string","example":"Label 'reference'=xxxxxx not found"}}},"inline_response_404_2":{"properties":{"message":{"type":"string","example":"Country not found"},"status":{"type":"string","example":"404"}}},"inline_response_400_2":{"properties":{"message":{"type":"string","example":"the param destination_country_code is mandatory"},"status":{"type":"string","example":"400"}}},"inline_response_400_3":{"type":"object","properties":{"status":{"type":"integer","description":"Error Code","example":400},"message":{"type":"string","description":"Error message","example":"Error: country not found"}}},"inline_response_200_5":{"type":"object","properties":{"price":{"type":"integer","description":"The price in € of the insurance for the given parameters."}}},"inline_response_400_4":{"type":"object","properties":{"status":{"type":"integer","description":"Error Code","example":400},"message":{"type":"string","description":"Error message","example":"Missing params"}}},"inline_response_200_6":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/PickupRequest"}},"meta":{"$ref":"#/components/schemas/Meta"}}},"inline_response_404_3":{"type":"object","properties":{"error":{"type":"string","example":"Couldn't find PickupRequest with 'id'=xxxx"}}},"pickup_requestsgenerate_pickup_request_pickup_address":{"type":"object","properties":{"last_name":{"type":"string","nullable":false,"example":"Bond"},"first_name":{"type":"string","nullable":false,"example":"James"},"full_name":{"maxLength":45,"type":"string","nullable":false,"example":"James Bond"},"address1":{"maxLength":35,"type":"string","nullable":false,"example":"3 Rue Gabriel Péri"},"address2":{"maxLength":35,"type":"string","nullable":true,"example":"Batiment A"},"address3":{"maxLength":35,"type":"string","nullable":true,"example":"Escalier B"},"country_code":{"maxLength":2,"type":"string","nullable":false,"example":"FR"},"city":{"maxLength":35,"type":"string","nullable":false,"example":"Toulouse"},"postcode":{"maxLength":12,"type":"string","nullable":false,"example":"31000"},"phone1":{"maxLength":25,"type":"string","nullable":false,"example":"0506070809"},"email":{"maxLength":50,"type":"string","nullable":true,"example":"james.bond@spy.en"},"company_name":{"maxLength":35,"type":"string","nullable":false,"example":"My Company"}},"description":"Pickup requestor informations","nullable":false},"pickup_requests_generate_pickup_request_body":{"type":"object","properties":{"carrier_name":{"type":"string","description":"Name of the carrier, the current possibilities are: [Dhl]","nullable":false,"example":"Dhl"},"pickup_timetsamp":{"type":"string","description":"Identifies the date and time the package is collected. The time is the local time of the shipment based on the shipper's time zone. The date component must be in the format: YYYY-MM-DD; The time component must be in the format: HH:MM:SS using a 24 hour clock. The date and time parts are separated by the letter T (e.g. 2010-02-05T14:00:00GMT+01:00). The chosen pickup timestamp must be preceding the pickup_location_close_time by at least 90 min","nullable":false,"example":"2020-08-18T10:00:00.000Z"},"pickup_location_close_time":{"type":"string","description":"Identifies the pickup location close time (i.e. what time do the premises where the collection is supposed to happen close). Thevalue must be in local time. The value component must be HH:MM (using a 24-hours clock format, e.g. 1:00).","nullable":false,"example":"19:00"},"pickup_location":{"maxLength":40,"type":"string","description":"Where the package should be picked up by DHL courier.","nullable":true,"example":"Mailbox"},"instructions":{"maxLength":75,"type":"string","description":"Any special instructions you wish to send to the courier for the order pick-up","nullable":true,"example":"Collect Carefully"},"pickup_address":{"$ref":"#/components/schemas/pickup_requestsgenerate_pickup_request_pickup_address"}}},"inline_response_201":{"properties":{"message":{"type":"string","example":"Collecte planifiée avec succès"},"dispatch_number":{"type":"string","description":"Created pickup_request's unique dispatch_number usable to get it","example":"PRG999126012345"}}},"inline_response_400_5":{"properties":{"code":{"type":"integer","example":400},"message":{"type":"string","description":"The error code 400 returns many kinds of errors. There are listed below with value 'possibleValueX' ","example":"{\"possibleValue1\":{\"value\":\"At least one label without pickup already planned is needed to schedule a pickup\",\"description\":\"This error occured when no label was found\"},\"possibleValue2\":{\"value\":\"Dhl indique que les valeurs recues sont incorrectes\",\"description\":\"Dhl error, details are listed in the body field.\"}}"},"body":{"type":"array","description":"the body contains dhl errors. In the documentation we list all errors, but usually, it contains only one of them","items":{"type":"object","oneOf":[{"$ref":"#/components/schemas/PickupRequestError5005"},{"$ref":"#/components/schemas/PickupRequestError5004"},{"$ref":"#/components/schemas/PickupRequestError5003"}]}}}},"Invoice_document":{"type":"object","properties":{"url":{"type":"string","description":"the path of the invoice","example":"https://url_of_invoice.pdf"}}},"Label_client":{"type":"object","properties":{"id":{"type":"string","description":"client id","example":"48675842"},"name":{"type":"string","description":"client name","example":"Barack Afritt"}}},"PickupRequest_pickup_address":{"type":"object","properties":{"lastname":{"type":"string","nullable":false,"example":"Bond"},"firstname":{"type":"string","nullable":false,"example":"James"},"fullname":{"type":"string","nullable":true,"example":"James Bond"},"address_line1":{"type":"string","nullable":false,"example":"3 Rue Gabriel Péri"},"address_line2":{"type":"string","nullable":true,"example":"Batiment A"},"address_line3":{"type":"string","nullable":true,"example":"Escalier B"},"country":{"type":"string","nullable":false,"example":"FR"},"city":{"type":"string","nullable":false,"example":"Toulouse"},"zip":{"type":"string","nullable":false,"example":"31000"},"phone1":{"type":"string","nullable":false,"example":"0506070809"},"email":{"type":"string","nullable":true,"example":"james.bond@spy.en"},"company_name":{"type":"string","nullable":false,"example":"My Company"}},"description":"Pickup requestor informations","nullable":false},"ServicesResponse_inner":{"type":"object","properties":{"carrier_name":{"type":"string","description":"Carrier Name","example":"Dhl"},"carrier_id":{"type":"integer","description":"carrier ID","example":1},"is_relay":{"type":"boolean","description":"Is this service using relay points ?","example":false},"name":{"type":"string","description":"name of the carrier service","example":"hom"},"verbose_name":{"type":"string","description":"The service fullname","example":"Mondial Relay - Point Relais"},"return_service":{"type":"boolean","description":"Is this service compatible with return ?","example":true},"is_express":{"type":"boolean","description":"Is it an express service ?","example":false},"is_domicile":{"type":"boolean","description":"Is it a domicile service ?","example":false},"with_sign":{"type":"boolean","description":"Is this service using signature ?","example":false}}},"item_senders":{"type":"object","properties":{"width":{"type":"integer","description":"The width of the item in cm","example":10},"length":{"type":"integer","description":"The length of the item in cm","example":20},"height":{"type":"integer","description":"The height of the item in cm","example":5},"weight":{"type":"integer","description":"The weight of the item in grams","example":1000},"price":{"type":"number","description":"The price of the item in euros","example":550}}},"CarrierServicesPricesResponse_inner":{"type":"object","properties":{"carrier_name":{"type":"string","description":"Carrier Name","example":"Dhl"},"oil_price":{"type":"integer","description":"Price of petrol tax (only with DHL for now)","example":0},"percentage_oil":{"type":"integer","description":"percentage of the price for petrol tax (only with DHL for now)","example":0},"price":{"type":"integer","description":"Price in without taxes in €"},"price_ttc":{"type":"integer","description":"price tax included"},"tva":{"type":"string","description":"percentage of tva tax","example":"20"},"carrier_service":{"type":"object","properties":{"is_relay":{"type":"boolean","description":"DEPRECATED Is the service relay based or not","example":false},"name":{"type":"string","description":"name of the service","example":"n"},"verbose_name":{"type":"string","description":"The service fullname","example":"Dhl: EXPRESS WORLDWIDE (Europe)"},"return_service":{"type":"boolean","description":"DEPRECATED","example":false}}}}},"PricingResponse_max_dimensions":{"type":"object","properties":{"max_added":{"type":"integer","description":"the maximal values in cm of (length + height + width)","example":150},"max_value":{"type":"integer","description":"The maximal value of the biggest dimension in cm.","example":120},"height":{"type":"integer","description":"The maximal height accepted by the carrier in cm.","example":80},"width":{"type":"integer","description":"The maximal width accepted by the carrier in cm.","example":80},"length":{"type":"integer","description":"The maximal length accepted by the carrier in cm.","example":120}},"description":"The maximal dimensions authorized by the carrier. Can either be in the { max_added, max_value } or { length, height, width } format depending on the carrier."},"inline_response_401_error":{"type":"object","properties":{"user_authentication":{"type":"object","example":"invalid credentials"}}}},"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}}},"x-readme":{"explorer-enabled":true,"proxy-enabled":true}}